# Class: Signal

## mixins/signalable~ Signal

A signal that can be raised on an object. When you deploy the `Signalable` mixin, it creates instances of these for you.

#### new Signal(host, name)

  ##### Parameters:

  Name | Type | Argument | Description
  --- | --- | --- | ---
  `host` | object | <nullable> | If hosted, you can identify the host here.
  `name` | string | <nullable> | The name of the signal

  Source:
    - mixins/signalable.js, line 53

### Methods

#### has(listener, listenerContext) → {boolean}

  Check if listener was attached to Signal.

  ##### Parameters:

  Name | Type | Argument | Description
  --- | --- | --- | ---
  `listener` | function |  | The function to check
  `listenerContext` | object | <nullable> | The context that was bound

  Source:
    - mixins/signalable.js, line 130

  ##### Returns:

  Type
    boolean

#### off(listener, listenerContext) → {function}

  Unbinds a listener to a signal.

  ##### Parameters:

  Name | Type | Argument | Description
  --- | --- | --- | ---
  `listener` | function |  | The function to unbind
  `listenerContext` | object | <nullable> | The context that was bound

  Source:
    - mixins/signalable.js, line 120

  ##### Returns:

  Type
    function

#### on(listener, listenerContext, priority) → {SignalBinding}

  Ties a listener to a signal.

  ##### Parameters:

  Name | Type | Argument | Description
  --- | --- | --- | ---
  `listener` | function |  | The function to call when the signal is raised
  `listenerContext` | object | <nullable> | A context to set for the listener. The event host may set a default for this value, but you may override that here.
  `priority` | number | <nullable> | A priority for the listener.

  Source:
    - mixins/signalable.js, line 83

  ##### Returns:

  Type
    SignalBinding

#### once(listener, listenerContext, priority) → {SignalBinding}

  Ties a listener to for a signal for one execution.

  ##### Parameters:

  Name | Type | Argument | Description
  --- | --- | --- | ---
  `listener` | function |  | The function to call when the signal is raised
  `listenerContext` | object | <nullable> | A context to set for the listener. The event host may set a default for this value, but you may override that here.
  `priority` | number | <nullable> | A priority for the listener.

  Source:
    - mixins/signalable.js, line 102

  ##### Returns:

  Type
    SignalBinding

#### toString()

  Strings!

  Source:
    - mixins/signalable.js, line 137